<?php

require_once('payment.tbank.model.php');

$request = (array)json_decode(file_get_contents('php://input'));
$payment_model = new Payment_tbank_model($this->diafan);
$payment = [];

if ($request) {
    if ($request['Success'] == 1 || $request['Success'] == 'true') {
        $request['Success'] = "true";
    } else {
        $request['Success'] = "false";
    }
    $payment = $payment_model->getPaymentByElementId($request['OrderId']);
}


switch ($_GET["rewrite"]) {

    case 'tbank/notification':
        if (!$payment) {
            die('PAYMENT NOT FOUND');
        }

        if ($payment_model->getToken($request, unserialize($payment['params'])['tbank_password']) != $request['Token']) {
            die('TOKEN INCORRECT');
        }

        if ((int)(round($payment_model->getPaymentByElementId($request['OrderId'])["summ"] *100)) !== (int)($request['Amount'])) {
            die('AMOUNTS DO NOT MATCH');
        }

        if ($request['Status'] == 'REFUNDED' || $request['Status'] == 'REJECTED') {
            // запрашиваем массив данных о статусе заказа, который будем устанавливать
            $canceled = DB::query_fetch_array("SELECT * FROM {shop_order_status} WHERE status='2' LIMIT 1");
            // запрашиваем массив данных о заказе, которому будем менять статус
            $order = DB::query_fetch_array("SELECT * FROM {shop_order} WHERE id=%d LIMIT 1", $request['OrderId']);
            // изменяем статус для заказа
            $this->diafan->_order->set_status($order, $canceled);
            die('OK');
        }

        if ($request['Status'] == 'CONFIRMED') {
            $this->diafan->_payment->success($payment, 'pay');
        }

        $payment_model->sendEmailToAdmin($payment["element_id"]);
        die('OK');

    case 'tbank/success':
        if (!$_GET['OrderId']) {
            Custom::inc('includes/404.php');
        }
        $payment = $payment_model->getPaymentByElementId($_GET['OrderId']);
        $this->diafan->_payment->success($payment, 'redirect');
        break;

    case 'tbank/failure':
        if (!$_GET['OrderId']) {
            Custom::inc('includes/404.php');
        }
        $payment = $payment_model->getPaymentByElementId($_GET['OrderId']);
        $this->diafan->_payment->fail($payment);
        break;

    default:
        Custom::inc('includes/404.php');
        break;
}
